# IPBlocksApi

## IPBlocksApi

All URIs are relative to *<https://api.ionos.com/cloudapi/v6>*

| Method                                             | HTTP request                     | Description                |
| -------------------------------------------------- | -------------------------------- | -------------------------- |
| [**ipblocks\_delete**](#ipblocks_delete)           | **DELETE** /ipblocks/{ipblockId} | Delete IP blocks           |
| [**ipblocks\_find\_by\_id**](#ipblocks_find_by_id) | **GET** /ipblocks/{ipblockId}    | Retrieve IP blocks         |
| [**ipblocks\_get**](#ipblocks_get)                 | **GET** /ipblocks                | List IP blocks             |
| [**ipblocks\_patch**](#ipblocks_patch)             | **PATCH** /ipblocks/{ipblockId}  | Partially modify IP blocks |
| [**ipblocks\_post**](#ipblocks_post)               | **POST** /ipblocks               | Reserve a IP Block         |
| [**ipblocks\_put**](#ipblocks_put)                 | **PUT** /ipblocks/{ipblockId}    | Modify a IP Block by ID    |

## **ipblocks\_delete**

> ipblocks\_delete(ipblock\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Delete IP blocks

Remove the specified IP block.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.IPBlocksApi(api_client)
    ipblock_id = 'ipblock_id_example' # str | The unique ID of the IP block.
    try:
        # Delete IP blocks
        api_instance.ipblocks_delete(ipblock_id)
    except ApiException as e:
        print('Exception when calling IPBlocksApi.ipblocks_delete: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **ipblock\_id**         | **str**  | The unique ID of the IP block.                                                                                                                                                                                                                                                                                                                                                                                                           |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

void (empty response body)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **ipblocks\_find\_by\_id**

> IpBlock ipblocks\_find\_by\_id(ipblock\_id, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Retrieve IP blocks

Retrieve the properties of the specified IP block.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.IPBlocksApi(api_client)
    ipblock_id = 'ipblock_id_example' # str | The unique ID of the IP block.
    try:
        # Retrieve IP blocks
        api_response = api_instance.ipblocks_find_by_id(ipblock_id)
        print(api_response)
    except ApiException as e:
        print('Exception when calling IPBlocksApi.ipblocks_find_by_id: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **ipblock\_id**         | **str**  | The unique ID of the IP block.                                                                                                                                                                                                                                                                                                                                                                                                           |                                |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**IpBlock**](/python-sdk/models/ipblock.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **ipblocks\_get**

> IpBlocks ipblocks\_get(pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number, offset=offset, limit=limit)

List IP blocks

List all reserved IP blocks.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.IPBlocksApi(api_client)
    try:
        # List IP blocks 
        api_response = api_instance.ipblocks_get()
        print(api_response)
    except ApiException as e:
        print('Exception when calling IPBlocksApi.ipblocks_get: %s\n' % e)
```

#### Parameters

| Name                    | Type     | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **pretty**              | **bool** | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**  | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**  | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |
| **offset**              | **int**  | The first element (from the complete list of the elements) to include in the response (used together with \<b>\<i>limit\</i>\</b> for pagination).                                                                                                                                                                                                                                                                                       | \[optional] \[default to 0]    |
| **limit**               | **int**  | The maximum number of elements to return (use together with offset for pagination).                                                                                                                                                                                                                                                                                                                                                      | \[optional] \[default to 100]  |

#### Return type

[**IpBlocks**](/python-sdk/models/ipblocks.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: Not defined
* **Accept**: application/json

## **ipblocks\_patch**

> IpBlock ipblocks\_patch(ipblock\_id, ipblock, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Partially modify IP blocks

Update the properties of the specified IP block.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.IPBlocksApi(api_client)
    ipblock_id = 'ipblock_id_example' # str | The unique ID of the IP block.
    ipblock = ionoscloud.IpBlockProperties() # IpBlockProperties | The properties of the IP block to be updated.
    try:
        # Partially modify IP blocks
        api_response = api_instance.ipblocks_patch(ipblock_id, ipblock)
        print(api_response)
    except ApiException as e:
        print('Exception when calling IPBlocksApi.ipblocks_patch: %s\n' % e)
```

#### Parameters

| Name                    | Type                                                             | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | ---------------------------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **ipblock\_id**         | **str**                                                          | The unique ID of the IP block.                                                                                                                                                                                                                                                                                                                                                                                                           |                                |
| **ipblock**             | [**IpBlockProperties**](/python-sdk/models/ipblockproperties.md) | The properties of the IP block to be updated.                                                                                                                                                                                                                                                                                                                                                                                            |                                |
| **pretty**              | **bool**                                                         | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                                          | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                                          | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**IpBlock**](/python-sdk/models/ipblock.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## **ipblocks\_post**

> IpBlock ipblocks\_post(ipblock, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Reserve a IP Block

Reserves a new IP block.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.IPBlocksApi(api_client)
    ipblock = ionoscloud.IpBlock() # IpBlock | The IP block to be reserved.
    try:
        # Reserve a IP Block
        api_response = api_instance.ipblocks_post(ipblock)
        print(api_response)
    except ApiException as e:
        print('Exception when calling IPBlocksApi.ipblocks_post: %s\n' % e)
```

#### Parameters

| Name                    | Type                                         | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **ipblock**             | [**IpBlock**](/python-sdk/models/ipblock.md) | The IP block to be reserved.                                                                                                                                                                                                                                                                                                                                                                                                             |                                |
| **pretty**              | **bool**                                     | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                      | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                      | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**IpBlock**](/python-sdk/models/ipblock.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json

## **ipblocks\_put**

> IpBlock ipblocks\_put(ipblock\_id, ipblock, pretty=pretty, depth=depth, x\_contract\_number=x\_contract\_number)

Modify a IP Block by ID

Modifies the properties of the specified IP block.

#### Example

```python
from __future__ import print_function
import time
import ionoscloud
from ionoscloud.rest import ApiException

# Defining the host is optional and defaults to https://api.ionos.com/cloudapi/v6
configuration = ionoscloud.Configuration(
    host = 'https://api.ionos.com/cloudapi/v6',
)

# Example of configuring HTTP Basic Authorization
configuration.username = 'YOUR_USERNAME'
configuration.password = 'YOUR_PASSWORD'

with ionoscloud.ApiClient(configuration) as api_client:
    # Create an instance of the API class
    api_instance = ionoscloud.IPBlocksApi(api_client)
    ipblock_id = 'ipblock_id_example' # str | The unique ID of the IP block.
    ipblock = ionoscloud.IpBlock() # IpBlock | The modified IP block.
    try:
        # Modify a IP Block by ID
        api_response = api_instance.ipblocks_put(ipblock_id, ipblock)
        print(api_response)
    except ApiException as e:
        print('Exception when calling IPBlocksApi.ipblocks_put: %s\n' % e)
```

#### Parameters

| Name                    | Type                                         | Description                                                                                                                                                                                                                                                                                                                                                                                                                              | Notes                          |
| ----------------------- | -------------------------------------------- | ---------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- | ------------------------------ |
| **ipblock\_id**         | **str**                                      | The unique ID of the IP block.                                                                                                                                                                                                                                                                                                                                                                                                           |                                |
| **ipblock**             | [**IpBlock**](/python-sdk/models/ipblock.md) | The modified IP block.                                                                                                                                                                                                                                                                                                                                                                                                                   |                                |
| **pretty**              | **bool**                                     | Controls whether the response is pretty-printed (with indentations and new lines).                                                                                                                                                                                                                                                                                                                                                       | \[optional] \[default to True] |
| **depth**               | **int**                                      | Controls the detail depth of the response objects. GET /datacenters/\[ID] - depth=0: Only direct properties are included; children (servers and other elements) are not included. - depth=1: Direct properties and children references are included. - depth=2: Direct properties and children properties are included. - depth=3: Direct properties and children properties and children's children are included. - depth=... and so on | \[optional] \[default to 0]    |
| **x\_contract\_number** | **int**                                      | Users with multiple contracts must provide the contract number, for which all API requests are to be executed.                                                                                                                                                                                                                                                                                                                           | \[optional]                    |

#### Return type

[**IpBlock**](/python-sdk/models/ipblock.md)

#### Authorization

Basic Authentication, Token Authentication

#### HTTP request headers

* **Content-Type**: application/json
* **Accept**: application/json


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.ionos.com/python-sdk/api/ipblocksapi.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
